#define USE_TI89
#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS
#define MIN_AMS 200
#include <tigcclib.h>

void _main(void)
{
	ESI argptr = top_estack;
	int n = ArgCount();						//# of arguments
	int rows = GetIntArg(argptr);	//# of rows (number of strings)
	int cols = GetIntArg(argptr);	//# of columns (length of longest string)
	int** array;									//string-containing, dynamically allocated array
	char i;												//loop variable
	
	//Prevents an accidental infinite loop
	if(n-2 > rows)
		ER_throw(40);
	
	//Allocate the number of rows in the array
	array = (int**) malloc(rows * sizeof(int*));
	
	//Reallocate each row of the array as another array; makes a 2D array
	for(i=0; i<rows; i++)
		array[i] = (int*) malloc(cols * sizeof(int));
	
	//Get any other arguments as strings from TI Home Screen
	for(i=0; i<n-2; i++)
		array[i] = GetStrnArg(argptr);

	//Return all the strings in a list form in the order as inputted
	push_END_TAG();
  for(i=rows; i>0; i--)
  		push_zstr(array[i-1]);
  push_LIST_TAG();
}